unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Cairo, Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  GL,
  OpenGLContext;

type

  { TForm1 }

  TForm1 = class(TForm)
    OpenGLControl1: TOpenGLControl;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    procedure DrawCairo(angele: Double);
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

procedure TForm1.DrawCairo(angele:Double);
var
  cr: Pcairo_t;
  cr_surface: Pcairo_surface_t;

  xc: double = 320;
  yc: double = 240;
  radius: double = 200;
  angele1: double = 45 * (pi / 180);
  angele2: double = 180 * (pi / 180);

  buffer:array of Byte=nil;
begin
  angele1:=angele;
  SetLength(buffer, OpenGLControl1.Width * OpenGLControl1.Height * 4);

  cr_surface := cairo_image_surface_create_for_data(PByte(buffer), CAIRO_FORMAT_RGB24, OpenGLControl1.Width, OpenGLControl1.Height, OpenGLControl1.Width*4);
//  cr_surface := cairo_image_surface_create_for_data(bit.RawImage.Data, CAIRO_FORMAT_RGB24, bit.Width, bit.Height, 640*4);

  cr := cairo_create(cr_surface);

  cairo_set_source_rgba(cr, 1, 1, 1, 1.0);
  cairo_rectangle(cr, 0, 0, 640, 480);
  cairo_fill(cr);

  cairo_set_source_rgba(cr, Random, 0, 0, 1.0);
  cairo_set_line_width(cr, 10.0);
  cairo_arc(cr, xc, yc, radius, angele1, angele2);
  cairo_stroke(cr);

  cairo_set_source_rgba(cr, 1, 0.2, 0.2, 0.6);
  cairo_set_line_width(cr, 6.0);

  cairo_arc(cr, xc, yc, 10.0, 0, 2 * pi);
  cairo_fill(cr);

  cairo_arc(cr, xc, yc, radius, angele1, angele1);
  cairo_line_to(cr, xc, yc);
  cairo_arc(cr, xc, yc, radius, angele2, angele2);
  cairo_line_to(cr, xc, yc);
  cairo_stroke(cr);

  glDrawPixels(OpenGLControl1.Width, OpenGLControl1.Height, GL_RGBA, GL_UNSIGNED_BYTE, Pointer(buffer));
  OpenGLControl1.SwapBuffers;

  cairo_destroy(cr);
  cairo_surface_destroy(cr_surface);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Timer1.Enabled:=False;
//  OpenGLControl1.Align := alClient;
  OpenGLControl1.AutoResizeViewport := False;
  OpenGLControl1.MakeCurrent();
  glClearColor(0, 0, 0, 0);

  Timer1.Interval:=10;
  Timer1.Enabled:=True;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
const
  an: Double=0.0;
begin
  an+=0.1;
  DrawCairo(an);
end;

end.
